#define GLOBE_VAR_DEF


#include "Stddef.h"
//#include <IO.h>
//#include <mem.h>
//#include <alloc.h>
//#include <sys/stat.h>


//---------------------
void ShowHelp(void)
{
	printf("\n======================================");
	printf("\n Nuvoton GPIO Tool (for NCT6116 only)");
	printf("\n                        Ver:2016-08-26");
	printf("\n======================================");

	printf("\nUsage: NuvGPIO gg m [l]");
	printf("\ngg, GPIO selection");
	printf("\nm, GPIO mode. 0b: Output; 1b: Input");
	printf("\nl, output level. 0b: Low; 1b: High");
	printf("\nEx: NuvGPIO 80 0 1, GPIO80 is an output pin and it output high level.");
	printf("\nEx: NuvGPIO 00 1, GPIO00 is an input pin and the return value is its level.");
}

int main(int argc, char **argv)
{
	bool bRet;
	ushort i, j, Hi, Lo;
	byte ucTemp;

	// process command line arguments
	for (i = 1; i < argc; i++)
	{
		if (strlen(argv[i]) > 30)
		{
			printf("\nInvalid Argument, %s.", argv[i]);
			return 2;
		}

		// force to translate to capital
		strupr(argv[i]);
		j = atoi(argv[i]);
		if (j == 0)
		{
			if (((strlen(argv[i]) == 1) && (argv[i][0] == '0')) ||
				((strlen(argv[i]) == 2) && (argv[i][0] == '0') && (argv[i][1] == '0')))
			{
			}
			else
			{
				// illegal argument
				ShowHelp();
				return 3;	//20101125, return fail:1, success:0
			}
		}

		if (i == 1) GPIO_SEL = j;
		if (i == 2) MODE = j;
		if (i == 3) LEVEL = j;
	}

	Hi = GPIO_SEL / 10;
	Lo = GPIO_SEL % 10;
	if ((Hi >= 9) || (Lo >= 9))
	{
		printf("\nUnknown GPIO !!!");
		return 4;	//fail:1, success:0
	}

	if ((MODE != 0) && (MODE != 1))
	{
		// illegal argument
		ShowHelp();
		return 5;
	}

	if ((LEVEL != 0) && (LEVEL != 1))
	{
		// illegal argument
		ShowHelp();
		return 6;
	}

	bRet = CheckSIO();
	if (bRet == false)
	{
		printf("\nNCT6116 cannot be found !");
		return 7;
	}

	bRet = _EnableGPIO(Hi, Lo);
	if (bRet == false)
	{
		printf("\nSet NCT6116 multi-function fail !");
		return 8;
	}

	// byte _GetGpioMode(int PortId, int BitId);

	bRet = _SetGpioMode(Hi, Lo, MODE);
	if (bRet == false)
	{
		if (MODE == 0) printf("\nSet GPIO%d%d to output mode fail !", Hi, Lo);
		if (MODE == 1) printf("\nSet GPIO%d%d to input mode fail !", Hi, Lo);
		return 9;
	}

	if (MODE == 0)
	{
		bRet = _SetGpioData(Hi, Lo, LEVEL);
		if (bRet == false)
		{
			if (LEVEL == 0) printf("\nSet GPIO%d%d output Low fail !", Hi, Lo);
			if (LEVEL == 1) printf("\nSet GPIO%d%d output High fail !", Hi, Lo);
			return 10;
		}
	}
	else
	{
		ucTemp = _GetGpioData(Hi, Lo);
		return ucTemp;
	}

	return 0;		//return fail:1, success:0
}
