#include "STDDEF.h"



//===================================================================
byte LogInfo(const unsigned char* format_msg, ...)
{
	unsigned char dspBuf[512], *p;
	va_list args;
	unsigned long n;

	// if (bVerbose == 0)  return 0;

	p = &dspBuf[0];
	va_start(args, format_msg);
	n = vsprintf(p, format_msg, args);
	va_end(args);

	if (EOF == n) return 1; //Buffer Overflow
	cprintf("%s", dspBuf);
	return 0;
}
//===================================================================

#ifndef TEXT_MODE
public static byte LpcInPortB(ushort IndexPort, ushort DataPort, byte LogicalDeviceNo, byte Index, NUVDRV_IOACCESS_CONFIG[] OpenConfig, NUVDRV_IOACCESS_CONFIG[] CloseConfig)
#else
byte LpcInPortB(ushort IndexPort, ushort DataPort, byte LogicalDeviceNo, byte Index)
#endif
{
    byte Data = 0xFF;

	#ifndef TEXT_MODE
	int i, j;


	HmAccessLock.WaitOne();

	if (OpenConfig != null)
	{
	    for (i = 0; i < OpenConfig.Length; i++)
		{
		    if (OpenConfig[i].Cmds == null) continue;
			for (j = 0; j < OpenConfig[i].Cmds.Length; j++)
				outportb(OpenConfig[i].Port, OpenConfig[i].Cmds[j]);
		}
	}
	#endif

	outportb(IndexPort, LPC_LOGICAL_DEVICE_OFFSET);
	outportb(DataPort, LogicalDeviceNo);
	outportb(IndexPort, Index);
	// inportb(DataPort, out Data);
	Data = inportb(DataPort);

	#ifndef TEXT_MODE
	if (CloseConfig != null)
	{
	    for (i = 0; i < CloseConfig.Length; i++)
		{
		    if (CloseConfig[i].Cmds == null) continue;
			for (j = 0; j < CloseConfig[i].Cmds.Length; j++)
				outportb(CloseConfig[i].Port, CloseConfig[i].Cmds[j]);
		}
	}

	HmAccessLock.ReleaseMutex();
	#endif
	
	return Data;
}

#ifndef TEXT_MODE
public static void LpcOutPortB(ushort IndexPort, ushort DataPort, byte LogicalDeviceNo, byte Index, byte Data, NUVDRV_IOACCESS_CONFIG[] OpenConfig, NUVDRV_IOACCESS_CONFIG[] CloseConfig)
#else
void LpcOutPortB(ushort IndexPort, ushort DataPort, byte LogicalDeviceNo, byte Index, byte Data)
#endif
{
    #ifndef TEXT_MODE
	int i, j;
	
    HmAccessLock.WaitOne();
	
	if (OpenConfig != null)
	{
	    for (i = 0; i < OpenConfig.Length; i++)
		{
		    if (OpenConfig[i].Cmds == null) continue;
			for (j = 0; j < OpenConfig[i].Cmds.Length; j++)
				outportb(OpenConfig[i].Port, OpenConfig[i].Cmds[j]);
		}
	}
	#endif

	outportb(IndexPort, LPC_LOGICAL_DEVICE_OFFSET);
	outportb(DataPort, LogicalDeviceNo);
	outportb(IndexPort, Index);
	outportb(DataPort, Data);

    #ifndef TEXT_MODE
	if (CloseConfig != null)
	{
	    for (i = 0; i < CloseConfig.Length; i++)
		{
		    if (CloseConfig[i].Cmds == null) continue;
			for (j = 0; j < CloseConfig[i].Cmds.Length; j++)
				outportb(CloseConfig[i].Port, CloseConfig[i].Cmds[j]);
		}
	}

	HmAccessLock.ReleaseMutex();
	#endif
}

#ifndef TEXT_MODE
public static bool CheckSIO()
#else
bool CheckSIO(void)
#endif
{
    byte ucIdx, ucHi, ucLo;

    IsDeviceReady = false;

    for (ucIdx = 0; ucIdx < 2; ucIdx++)
	{
	    if (ucIdx == 0)
		{
		    EFER = 0x4E;
			LogInfo("Try 4E");
		}
		else
		{
			EFER = 0x2E;
			LogInfo("Try 2E");
		}

		EFIR = EFER;
		EFDR = (UInt16)(EFER + 1);
		outportb(EFER, 0xAA);
		outportb(EFER, 0x87);
		outportb(EFER, 0x87);

		outportb(EFIR, 0x20);
		// inportb(EFDR, out ucHi);
		ucHi = inportb(EFDR);

		outportb(EFIR, 0x21);
        // inportb(EFDR, out ucLo);
        ucLo = inportb(EFDR);

        #ifndef TEXT_MODE
        LogInfo(string.Format("ChipID_Hi=0x{0:X}, ChipID_Lo=0x{1:X}.", ucHi, ucLo));
	    #else
        LogInfo("ChipID_Hi=0x%02X, ChipID_Lo=0x%02X.", ucHi, ucLo);
		#endif

        if ((ucHi != 0xFF) || (ucLo != 0xFF))
		{
		    if ((ucHi == 0xD2) && ((ucLo & 0x80) == 0x80))
			{
				CHIP = NCT6116;
				IsDeviceReady = true;
				return true;
			}
		}
	}

	return false;
}

#ifndef TEXT_MODE
public static bool _EnableGPIO(int PortId, int BitId)
#else
bool _EnableGPIO(int PortId, int BitId)
#endif
{
    byte Data = 0xFF;

    #ifndef TEXT_MODE
	HwAccessLock.WaitOne();
	#endif

	if (CHIP == NCT6116)
	{
	    switch (PortId)
		{
		    case 0:
				outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
				outportb(EFDR, 0x07);
				outportb(EFIR, 0x30);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
				Data = (byte)(Data | ((byte)1 << PortId));
				outportb(EFDR, Data);

				// Multi-function Pin
				// 1Dh, Bit[4] = 0b
				outportb(EFIR, 0x1D);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
				Data = (byte)(Data & 0xEF);
				outportb(EFDR, Data);

				// 1Ch, Bit[3:2] = 00b
				outportb(EFIR, 0x1C);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
				Data = (byte)(Data & 0xF3);
				outportb(EFDR, Data);

				// Multi-function Select
				outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
				outportb(EFDR, 0x08);

				outportb(EFIR, 0xE0);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
				Data = (byte)(Data & ~(byte)(1 << BitId));
				outportb(EFDR, Data);
				break;

			case 1:
				outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
				outportb(EFDR, 0x07);
				outportb(EFIR, 0x30);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
				Data = (byte)(Data | ((byte)1 << PortId));
				outportb(EFDR, Data);

				// Multi-function Pin
				// 1Ch, Bit[7] = 0b
				outportb(EFIR, 0x1C);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
				Data = (byte)(Data & 0x7F);
				outportb(EFDR, Data);

				// 1Dh, Bit[1:0] = 00b
				outportb(EFIR, 0x1D);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
				Data = (byte)(Data & 0xFC);
				outportb(EFDR, Data);

				// Multi-function Select
				outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
				outportb(EFDR, 0x08);

				outportb(EFIR, 0xE1);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
				Data = (byte)(Data & ~(byte)(1 << BitId));
				outportb(EFDR, Data);
				break;

			case 2:
				outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
				outportb(EFDR, 0x07);
				outportb(EFIR, 0x30);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
				Data = (byte)(Data | ((byte)1 << PortId));
				outportb(EFDR, Data);

				// Multi-function Pin
				// 2Bh, Bit[7] = 0b
				outportb(EFIR, 0x2B);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);				
				Data = (byte)(Data & 0x7F);
				outportb(EFDR, Data);

				// 1Ch, Bit[1] = 0b
				outportb(EFIR, 0x1C);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data & 0xFD);
                outportb(EFDR, Data);

                // Multi-function Select
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x08);

                outportb(EFIR, 0xE2);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data & ~(byte)(1 << BitId));
                outportb(EFDR, Data);
                break;

            case 3:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);
                outportb(EFIR, 0x30);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data | ((byte)1 << PortId));
                outportb(EFDR, Data);

                // Multi-function Pin
                // 1Ah, Bit[5:4] = 00b
                outportb(EFIR, 0x1A);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data & 0xCF);
                outportb(EFDR, Data);

                // Multi-function Select
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x08);

                outportb(EFIR, 0xE3);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data & ~(byte)(1 << BitId));
                outportb(EFDR, Data);
                break;

            case 4:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);
                outportb(EFIR, 0x30);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data | ((byte)1 << PortId));
                outportb(EFDR, Data);

                // Multi-function Pin
                // 1Ah, Bit[5:4] = 00b
                outportb(EFIR, 0x1A);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data & 0xCF);
                outportb(EFDR, Data);

                // Multi-function Select
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x08);

                outportb(EFIR, 0xE4);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data & ~(byte)(1 << BitId));
                outportb(EFDR, Data);
                break;

            case 5:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);
                outportb(EFIR, 0x30);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data | ((byte)1 << PortId));
                outportb(EFDR, Data);

                // Multi-Function Pin
                if (BitId == 0)
                {
                    // (KBC_EN) 2Fh, Bit[4] = 0b
                    outportb(EFIR, 0x2F);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xEF);
                    outportb(EFDR, Data);

                    // 1Ah, Bit[3] = 1b
                    outportb(EFIR, 0x1A);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x08);
                    outportb(EFDR, Data);
                }
                else if (BitId == 1)
                {
                    // KBC_EN = 0b
                    outportb(EFIR, 0x2F);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xEF);
                    outportb(EFDR, Data);

                    // 1Ah, Bit[3] = 1b
                    outportb(EFIR, 0x1A);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x08);
                    outportb(EFDR, Data);
                }
                else if (BitId == 2)
                {
                    // KBC_EN = 0b
                    outportb(EFIR, 0x2F);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xEF);
                    outportb(EFDR, Data);

                    // 1Ah, Bit[2] = 0b
                    outportb(EFIR, 0x1A);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFB);
                    outportb(EFDR, Data);
                }
                else if (BitId == 3)
                {
                    // KBC_EN = 0b
                    outportb(EFIR, 0x2F);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xEF);
                    outportb(EFDR, Data);

                    // 1Ah, Bit[2] = 0b
                    outportb(EFIR, 0x1A);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFB);
                    outportb(EFDR, Data);
                }
                else if (BitId == 4)
                {
                    // 1Ah, Bit[1] = 1b
                    outportb(EFIR, 0x1A);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x02);
                    outportb(EFDR, Data);
                }
                else if (BitId == 5)
                {
                    // 1Ah, Bit[0] = 1b
                    outportb(EFIR, 0x1A);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x01);
                    outportb(EFDR, Data);
                }
                else if (BitId == 6)
                {
                    // 1Bh, Bit[7] = 1b
                    outportb(EFIR, 0x1B);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x80);
                    outportb(EFDR, Data);

                    // LDN_E, E6h, Bit[6] = 0b
                    outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                    outportb(EFDR, 0x0E);

                    outportb(EFIR, 0xE6);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xBF);
                    outportb(EFDR, Data);
                }
                else if (BitId == 7)
                {
                    // 1Bh, Bit[6] = 1b
                    outportb(EFIR, 0x1B);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x40);
                    outportb(EFDR, Data);
                }

                // Multi-function Select
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x08);

                outportb(EFIR, 0xE5);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data & ~(byte)(1 << BitId));
                outportb(EFDR, Data);
                break;

            case 6:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);
                outportb(EFIR, 0x30);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data | ((byte)1 << PortId));
                outportb(EFDR, Data);

                // Multi-function Pin
                if (BitId == 0)
                {
                    // 1Bh, Bit[5] = 1b
                    outportb(EFIR, 0x1B);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x20);
                    outportb(EFDR, Data);
                }
                else if (BitId == 1)
                {
                    // 1Bh, Bit[4] = 1b
                    outportb(EFIR, 0x1B);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x10);
                    outportb(EFDR, Data);
                }
                else if (BitId == 2)
                {
                    // 1Bh, Bit[3] = 1b
                    outportb(EFIR, 0x1B);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x08);
                    outportb(EFDR, Data);
                }
                else if (BitId == 3)
                {
                    // 1Bh, Bit[1:0] = 00b
                    outportb(EFIR, 0x1B);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFC);
                    outportb(EFDR, Data);

                    // 2Ah, Bit[1] = 0b
                    outportb(EFIR, 0x2A);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFD);
                    outportb(EFDR, Data);
                }
                else if (BitId == 4)
                {
                    // 1Bh, Bit[1:0] = 00b
                    outportb(EFIR, 0x1B);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFC);
                    outportb(EFDR, Data);

                    // 2Ah, Bit[1] = 0b
                    outportb(EFIR, 0x2A);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFD);
                    outportb(EFDR, Data);
                }
                else if (BitId == 5)
                {
                    // DSW_EN = 0b
                    outportb(EFIR, 0x2F);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFB);
                    outportb(EFDR, Data);

                    // 1Ch, Bit[6] = 1b
                    outportb(EFIR, 0x1C);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x40);
                    outportb(EFDR, Data);
                }
                else if (BitId == 6)
                {
                    // DSW_EN = 0b
                    outportb(EFIR, 0x2F);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFB);
                    outportb(EFDR, Data);

                    // 1Ch, Bit[5] = 1b
                    outportb(EFIR, 0x1C);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x20);
                    outportb(EFDR, Data);
                }
                else if (BitId == 7)
                {
                    // 27h, Bit[2] = 0b
                    outportb(EFIR, 0x27);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFB);
                    outportb(EFDR, Data);

                    // 1Ch, Bit[4] = 1b
                    outportb(EFIR, 0x1C);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x10);
                    outportb(EFDR, Data);
                }

                // Multi-function Select
                if (BitId == 7)
                {
                    outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                    outportb(EFDR, 0x08);

                    outportb(EFIR, 0xE7);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0x1F);
                    outportb(EFDR, Data);
                }
                else
                {
                    outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                    outportb(EFDR, 0x08);

                    outportb(EFIR, 0xE6);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & ~(byte)(1 << BitId));
                    outportb(EFDR, Data);
                }
                break;

            case 7:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);
                outportb(EFIR, 0x30);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data | ((byte)1 << PortId));
                outportb(EFDR, Data);

                // Multi-function Pin
                // (PORT80_Strp) 2Fh, Bit[1] = 0b
                outportb(EFIR, 0x2F);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data & 0xFD);
                outportb(EFDR, Data);

                // 2Bh, Bit[5] = 0b
                outportb(EFIR, 0x2B);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data & 0xDF);
                outportb(EFDR, Data);

                // Multi-function Select
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x08);

                outportb(EFIR, 0xE8);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data & ~(byte)(1 << BitId));
                outportb(EFDR, Data);
                break;

            case 8:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x09);
                outportb(EFIR, 0x30);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                Data = (byte)(Data | ((byte)1 << (PortId - 8)));
                outportb(EFDR, Data);

                if (BitId == 0)
                {
                    // 2Bh, Bit[4] = 1b
                    outportb(EFIR, 0x2B);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x10);
                    outportb(EFDR, Data);
                }
                else if (BitId == 1)
                {
                    // 2Bh, Bit[4] = 1b
                    outportb(EFIR, 0x2B);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x10);
                    outportb(EFDR, Data);
                }
                else if (BitId == 2)
                {
                    // 2Bh, Bit[3] = 0b
                    outportb(EFIR, 0x2B);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xF7);
                    outportb(EFDR, Data);
                }
                else if (BitId == 3)
                {
                    // DSW_EN = 0b
                    outportb(EFIR, 0x2F);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFB);
                    outportb(EFDR, Data);
                }
                else if (BitId == 4)
                {
                    // (WDT_EN) 2Dh, Bit[0] = 0b
                    outportb(EFIR, 0x2D);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFE);
                    outportb(EFDR, Data);

                    // 2Ah, Bit[3] = 1b
                    outportb(EFIR, 0x2A);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x08);
                    outportb(EFDR, Data);
                }
                else if (BitId == 5)
                {
                    // LDN_E, E6h, Bit[7] = 1b
                    outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                    outportb(EFDR, 0x0E);

                    outportb(EFIR, 0xE6);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x80);
                    outportb(EFDR, Data);
                }
                else if (BitId == 6)
                {
                    // DSW_EN = 0b
                    outportb(EFIR, 0x2F);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFB);
                    outportb(EFDR, Data);

                    // 1Ah, Bit[7] = 0b
                    outportb(EFIR, 0x1A);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0x7F);
                    outportb(EFDR, Data);

                    // 1Bh, Bit[2] = 0b
                    outportb(EFIR, 0x1B);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFB);
                    outportb(EFDR, Data);

                    // 1Ch, Bit[7] = 0b
                    outportb(EFIR, 0x1C);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0x7F);
                    outportb(EFDR, Data);
                }
                else if (BitId == 7)
                {
                    // (DSW_EN) 2Fh, Bit[2] = 0b
                    outportb(EFIR, 0x2F);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data & 0xFB);
                    outportb(EFDR, Data);

                    // 1Dh, Bit[3] = 1b
                    outportb(EFIR, 0x1D);
					// inportb(EFDR, out Data);
					Data = inportb(EFDR);
                    Data = (byte)(Data | 0x08);
                    outportb(EFDR, Data);
                }

                // Multi-function Select
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x08);

                outportb(EFIR, 0xE9);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                Data = (byte)(Data & ~(byte)(1 << BitId));
                outportb(EFDR, Data);
                break;

            default:
                break;
        }
    }

	#ifndef TEXT_MODE
    HwAccessLock.ReleaseMutex();
	#endif
    return true;
}

#ifndef TEXT_MODE
public static byte _GetGpioMode(int PortId, int BitId)
#else
byte _GetGpioMode(int PortId, int BitId)
#endif
{
    byte Data = 0xFF;

	if (CHIP == NCT6116)
    {
        switch (PortId)
        {
            case 0:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xE0);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else                                  Data = 0x01;
                break;

            case 1:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xE4);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else                                  Data = 0x01;
                break;

            case 2:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xE8);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else                                  Data = 0x01;
                break;

            case 3:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xEC);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else                                  Data = 0x01;
                break;

            case 4:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xF0);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else                                  Data = 0x01;
                break;

            case 5:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xF4);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else                                  Data = 0x01;
                break;

            case 6:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xF8);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else                                  Data = 0x01;
                break;

            case 7:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xFC);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else                                  Data = 0x01;
                break;

            case 8:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x09);

                outportb(EFIR, 0xF0);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else                                  Data = 0x01;
                break;
        }
    }

    return Data;
}

#ifndef TEXT_MODE
public static bool _SetGpioMode(int PortId, int BitId, byte Direction)
#else
bool _SetGpioMode(int PortId, int BitId, byte Direction)
#endif
{
    byte Data = 0xFF;

	if (CHIP == NCT6116)
    {
        switch (PortId)
        {
            case 0:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xE0);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                else                Data = (byte)(Data | (byte)(1 << BitId));
                outportb(EFDR, Data);

                // PP in output mode
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x0F);

                outportb(EFIR, 0xE0);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                outportb(EFDR, Data);
                break;

            case 1:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xE4);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                else Data = (byte)(Data | (byte)(1 << BitId));
                outportb(EFDR, Data);

                // PP in output mode
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x0F);

                outportb(EFIR, 0xE1);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                outportb(EFDR, Data);
                break;

            case 2:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xE8);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                else Data = (byte)(Data | (byte)(1 << BitId));
                outportb(EFDR, Data);

                // PP in output mode
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x0F);

                outportb(EFIR, 0xE2);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                outportb(EFDR, Data);
                break;

            case 3:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xEC);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                else Data = (byte)(Data | (byte)(1 << BitId));
                outportb(EFDR, Data);

                // PP in output mode
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x0F);

                outportb(EFIR, 0xE3);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                outportb(EFDR, Data);
                break;

            case 4:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xF0);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                else Data = (byte)(Data | (byte)(1 << BitId));
                outportb(EFDR, Data);

                // PP in output mode
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x0F);

                outportb(EFIR, 0xE4);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                outportb(EFDR, Data);
                break;

            case 5:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xF4);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                else Data = (byte)(Data | (byte)(1 << BitId));
                outportb(EFDR, Data);

                // PP in output mode
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x0F);

                outportb(EFIR, 0xE5);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                outportb(EFDR, Data);
                break;

            case 6:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xF8);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                else Data = (byte)(Data | (byte)(1 << BitId));
                outportb(EFDR, Data);

                // PP in output mode
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x0F);

                outportb(EFIR, 0xE6);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                outportb(EFDR, Data);
                break;

            case 7:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xFC);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                else Data = (byte)(Data | (byte)(1 << BitId));
                outportb(EFDR, Data);

                // PP in output mode
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x0F);

                outportb(EFIR, 0xE7);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                outportb(EFDR, Data);
                break;

            case 8:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x09);

                outportb(EFIR, 0xF0);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                else Data = (byte)(Data | (byte)(1 << BitId));
                outportb(EFDR, Data);

                // PP in output mode
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x0F);

                outportb(EFIR, 0xE8);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if (Direction == 0) Data = (byte)(Data & ~((byte)(1 << BitId)));
                outportb(EFDR, Data);
                break;

            default:
                break;
        }
    }

    return true;
}

#ifndef TEXT_MODE
public static byte _GetGpioData(int PortId, int BitId)
#else
byte _GetGpioData(int PortId, int BitId)
#endif
{
    byte Data = 0xFF;

	if (CHIP == NCT6116)
    {
        switch (PortId)
        {
            case 0:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xE1);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);
                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else Data = 0x01;
                break;

            case 1:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xE5);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else Data = 0x01;
                break;

            case 2:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xE9);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else Data = 0x01;
                break;

            case 3:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xED);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else Data = 0x01;
                break;

            case 4:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xF1);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else Data = 0x01;
                break;

            case 5:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xF5);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else Data = 0x01;
                break;

            case 6:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xF9);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else Data = 0x01;
                break;

            case 7:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xFD);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else Data = 0x01;
                break;

            case 8:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x09);

                outportb(EFIR, 0xF1);
				// inportb(EFDR, out Data);
				Data = inportb(EFDR);

                if ((Data & (byte)(1 << BitId)) == 0) Data = 0x00;
                else Data = 0x01;
                break;
        }
    }

    #ifndef TEXT_MODE
	LogInfo(string.Format("2, GP{0:d}{1:d}, data=0x{0:X}", PortId, BitId, Data));
	#else
	LogInfo("2, GP%d%d, data=0x%02X", PortId, BitId, Data);
    #endif
    return Data;
}

#ifndef TEXT_MODE
public static bool _SetGpioData(int PortId, int BitId, byte Data)
#else
bool _SetGpioData(int PortId, int BitId, byte Data)
#endif
{
    byte bData = 0xFF;

	if (CHIP == NCT6116)
	{
		switch (PortId)
		{
			case 0:
				outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
				outportb(EFDR, 0x07);

				outportb(EFIR, 0xE1);
				// inportb(EFDR, out Data);
				bData = inportb(EFDR);

				if (Data == 0) bData = (byte)(bData & ~((byte)(1 << BitId)));
				else bData = (byte)(bData | (byte)(1 << BitId));
				outportb(EFDR, bData);
				break;

			case 1:
				outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
				outportb(EFDR, 0x07);

                outportb(EFIR, 0xE5);
				// inportb(EFDR, out Data);
				bData = inportb(EFDR);

                if (Data == 0) bData = (byte)(bData & ~((byte)(1 << BitId)));
                else bData = (byte)(bData | (byte)(1 << BitId));
                outportb(EFDR, bData);
                break;

            case 2:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xE9);
				// inportb(EFDR, out Data);
				bData = inportb(EFDR);

                if (Data == 0) bData = (byte)(bData & ~((byte)(1 << BitId)));
                else bData = (byte)(bData | (byte)(1 << BitId));
                outportb(EFDR, bData);
                break;

            case 3:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xED);
				// inportb(EFDR, out Data);
				bData = inportb(EFDR);

                if (Data == 0) bData = (byte)(bData & ~((byte)(1 << BitId)));
                else bData = (byte)(bData | (byte)(1 << BitId));
                outportb(EFDR, bData);
                break;

            case 4:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xF1);
				// inportb(EFDR, out Data);
				bData = inportb(EFDR);

                if (Data == 0) bData = (byte)(bData & ~((byte)(1 << BitId)));
                else bData = (byte)(bData | (byte)(1 << BitId));
                outportb(EFDR, bData);
                break;

            case 5:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xF5);
				// inportb(EFDR, out Data);
				bData = inportb(EFDR);

                if (Data == 0) bData = (byte)(bData & ~((byte)(1 << BitId)));
                else bData = (byte)(bData | (byte)(1 << BitId));
                outportb(EFDR, bData);
                break;

            case 6:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xF9);
				// inportb(EFDR, out Data);
				bData = inportb(EFDR);

                if (Data == 0) bData = (byte)(bData & ~((byte)(1 << BitId)));
                else bData = (byte)(bData | (byte)(1 << BitId));
                outportb(EFDR, bData);
                break;

            case 7:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x07);

                outportb(EFIR, 0xFD);
				// inportb(EFDR, out Data);
				bData = inportb(EFDR);

                if (Data == 0) bData = (byte)(bData & ~((byte)(1 << BitId)));
                else bData = (byte)(bData | (byte)(1 << BitId));
                outportb(EFDR, bData);
                break;

            case 8:
                outportb(EFIR, LPC_LOGICAL_DEVICE_OFFSET);
                outportb(EFDR, 0x09);

                outportb(EFIR, 0xF1);
				// inportb(EFDR, out Data);
				bData = inportb(EFDR);

                if (Data == 0) bData = (byte)(bData & ~((byte)(1 << BitId)));
                else bData = (byte)(bData | (byte)(1 << BitId));
                outportb(EFDR, bData);
                break;

            default:
                break;
        }
    }

    return true;
}

