// #define DOS_VER
#define LINUX_VER

#ifdef DOS_VER
	#define TEXT_MODE
#endif

#ifdef LINUX_VER
	#define TEXT_MODE
#endif


#define out
#define in


#define bool unsigned char
	#define true 1
	#define false 0

#define byte unsigned char

#ifdef LINUX_VER
#define ushort u_short
#define UInt16 u_short
#else
#define ushort unsigned short
#define UInt16 unsigned short
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#ifdef DOS_VER
#include <conio.h>
#endif

#ifdef LINUX_VER
#include <stdint.h>
#include <sys/io.h>
#include <unistd.h>
//#define IO_READ 1
//#define IO_WRITE 2
//#define IO_RDWR (IO_READ | IO_WRITE)

#define inportb(x) inb(x)
#define outportb(x,y) outb(y,x)

#endif

typedef enum { NCT6116 }WBCHIP ;

#define LPC_LOGICAL_DEVICE_OFFSET 0x07

#ifndef GLOBE_VAR_DEF
    ushort EFER, EFIR, EFDR;
	bool IsDeviceReady;
	WBCHIP CHIP;
    ushort GPIO_SEL;
    byte MODE;
    byte LEVEL;
#else
    extern ushort EFER, EFIR, EFDR;
    extern bool IsDeviceReady;
	extern WBCHIP CHIP;
    extern ushort GPIO_SEL;
    extern byte MODE;
    extern byte LEVEL;
#endif



// function declaration
byte LpcInPortB(ushort IndexPort, ushort DataPort, byte LogicalDeviceNo, byte Index);
void LpcOutPortB(ushort IndexPort, ushort DataPort, byte LogicalDeviceNo, byte Index, byte Data);
bool CheckSIO(void);
bool _EnableGPIO(int PortId, int BitId);
byte _GetGpioMode(int PortId, int BitId);
bool _SetGpioMode(int PortId, int BitId, byte Direction);
byte _GetGpioData(int PortId, int BitId);
bool _SetGpioData(int PortId, int BitId, byte Data);

byte LogInfo(const unsigned char* format_msg, ...);

