﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using NNuvHwAccCtrl;
using System.IO;

namespace GPIO
{
    public partial class Form1 : Form
    {
        static bool bLoad;
        static bool bNuvotonIO;
        static bool bUnderPolling = false;
        static byte[] GPIOEn = new byte[9];

        int i, j;
        Label[] _Labels = new Label[9];
        GroupBox[] _GroupBoxs = new GroupBox[9];
        RadioButton[] _RadioButtons = new RadioButton[18];
        ComboBox[] _ComboBox = new ComboBox[9];
        CheckBox[] _CheckBox = new CheckBox[9];

        public Form1()
        {
            InitializeComponent();
            string logFilePath = Path.Combine(Application.StartupPath, "log4net.config");
            FileInfo finfo = new FileInfo(logFilePath);
            log4net.Config.XmlConfigurator.ConfigureAndWatch(finfo);

            bLoad = NuvHwAccCtrl.NuvHwCtrl_Load();
            if (bLoad == false)
            {
                this.Text = "Load Driver Fail";
            }

            _Labels[0] = label1;
            _Labels[1] = label2;
            _Labels[2] = label3;
            _Labels[3] = label4;
            _Labels[4] = label5;
            _Labels[5] = label6;
            _Labels[6] = label7;
            _Labels[7] = label8;
            _Labels[8] = label9;

            _GroupBoxs[0] = groupBox2;
            _GroupBoxs[1] = groupBox4;
            _GroupBoxs[2] = groupBox6;
            _GroupBoxs[3] = groupBox8;
            _GroupBoxs[4] = groupBox10;
            _GroupBoxs[5] = groupBox12;
            _GroupBoxs[6] = groupBox14;
            _GroupBoxs[7] = groupBox16;
            _GroupBoxs[8] = groupBox18;

            _RadioButtons[0] = radioButton1;
            _RadioButtons[1] = radioButton2;
            _RadioButtons[2] = radioButton3;
            _RadioButtons[3] = radioButton4;
            _RadioButtons[4] = radioButton5;
            _RadioButtons[5] = radioButton6;
            _RadioButtons[6] = radioButton7;
            _RadioButtons[7] = radioButton8;
            _RadioButtons[8] = radioButton9;
            _RadioButtons[9] = radioButton10;
            _RadioButtons[10] = radioButton11;
            _RadioButtons[11] = radioButton12;
            _RadioButtons[12] = radioButton13;
            _RadioButtons[13] = radioButton14;
            _RadioButtons[14] = radioButton15;
            _RadioButtons[15] = radioButton16;
            _RadioButtons[16] = radioButton17;
            _RadioButtons[17] = radioButton18;

            _ComboBox[0] = comboBox1;
            _ComboBox[1] = comboBox2;
            _ComboBox[2] = comboBox3;
            _ComboBox[3] = comboBox4;
            _ComboBox[4] = comboBox5;
            _ComboBox[5] = comboBox6;
            _ComboBox[6] = comboBox7;
            _ComboBox[7] = comboBox8;
            _ComboBox[8] = comboBox9;

            _CheckBox[0] = checkBox1;
            _CheckBox[1] = checkBox2;
            _CheckBox[2] = checkBox3;
            _CheckBox[3] = checkBox4;
            _CheckBox[4] = checkBox5;
            _CheckBox[5] = checkBox6;
            _CheckBox[6] = checkBox7;
            _CheckBox[7] = checkBox8;
            _CheckBox[8] = checkBox9;

            bNuvotonIO = NuvHwAccCtrl.CheckSIO();
            if (!bNuvotonIO)
            {
                MessageBox.Show("NCT6116 can't be found", "Important Note", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                return;
            }

            NuvHwAccCtrl.IniPath = Path.Combine(Application.StartupPath, "NuvGpio.INI");
            NuvHwAccCtrl.LogInfo("INI: " + NuvHwAccCtrl.IniPath);

            if (NuvHwAccCtrl.CHIP == WBCHIP.NCT6116)
            {
                string val, Key;
                byte REG_EN, REG_MODE, REG_DATA;

                for (i = 0; i < 9; i++)
                {
                    Key = "";
                    j = 0;
                    try
                    {
                        NuvHwAccCtrl.LogDebug(String.Format("i = {0:X}, j = {1:X}", i, j));

                        // GPIO0E = 0xFF
                        Key = String.Format("GPIO{0:X}E", i);
                        val = NuvHwAccCtrl.IniReadValue("6116", Key);
                        if (val != "") REG_EN = Convert.ToByte(val, 16);
                        else REG_EN = 0x00;

                        GPIOEn[i] = REG_EN;
                        NuvHwAccCtrl.LogDebug(Key + String.Format(" = {0:X}, REG_EN = 0x{1:X}", val, REG_EN));

                        // GPIO0Mode = 0x00
                        Key = String.Format("GPIO{0:X}Mode", i);
                        val = NuvHwAccCtrl.IniReadValue("6116", Key);
                        if (val != "") REG_MODE = Convert.ToByte(val, 16);
                        else REG_MODE = 0x00;
                        NuvHwAccCtrl.LogDebug(Key + String.Format(" = {0:X}, REG_MODE = 0x{1:X}", val, REG_MODE));

                        // GPIO0 = 0x00
                        Key = String.Format("GPIO{0:X}", i);
                        val = NuvHwAccCtrl.IniReadValue("6116", Key);
                        if (val != "") REG_DATA = Convert.ToByte(val, 16);
                        else REG_DATA = 0x00;
                        NuvHwAccCtrl.LogDebug(Key + String.Format(" = {0:X}, REG_DATA = 0x{1:X}", val, REG_DATA));
                    }
                    catch (Exception e)
                    {
                        NuvHwAccCtrl.LogDebug("Exception: " + e.Message);

                        REG_EN = 0x00;
                        REG_MODE = 0xFF;
                        REG_DATA = 0x00;
                    }

                    if (REG_EN == 0x00)
                    {
                        _GroupBoxs[i].Enabled = false;
                        // _ComboBox[i].SelectedIndex = 0;
                        // _CheckBox[i].Checked = false;
                        _CheckBox[i].Enabled = false;
                    }
                    else
                    {
                        for (j = 0; j < 8; j++)
                        {
                            // default value depends on the setting in INI
                            if ((REG_EN & (byte)(1 << j)) != 0)
                            {
                                NuvHwAccCtrl._EnableGPIO(i, j);

                                if ((REG_MODE & (byte)(1 << j)) != 0)
                                {
                                    NuvHwAccCtrl._SetGpioMode(i, j, 1);

                                    if (j == 0)
                                    {
                                        if (NuvHwAccCtrl._GetGpioData(i, j) == 0x00)
                                        {
                                            _Labels[i].Text = "0";
                                            _RadioButtons[i * 2].Checked = true;
                                        }
                                        else
                                        {
                                            _Labels[i].Text = "1";
                                            _RadioButtons[i * 2 + 1].Checked = true;
                                        }

                                        _GroupBoxs[i].Enabled = false;
                                        // _ComboBox[i].SelectedIndex = 0;
                                        _CheckBox[i].Checked = false;
                                    }
                                }
                                else
                                {
                                    NuvHwAccCtrl._SetGpioMode(i, j, 0);

                                    if ((REG_DATA & (byte)(1 << j)) != 0) NuvHwAccCtrl._SetGpioData(i, j, 1);
                                    else NuvHwAccCtrl._SetGpioData(i, j, 0);

                                    if (j == 0)
                                    {
                                        if ((REG_DATA & (byte)(1 << j)) == 0)
                                        {
                                            // _Labels[i].Text = "0";
                                            _RadioButtons[i * 2].Checked = true;
                                        }
                                        else
                                        {
                                            // _Labels[i].Text = "1";
                                            _RadioButtons[i * 2 + 1].Checked = true;
                                        }

                                        _GroupBoxs[i].Enabled = true;
                                        // _ComboBox[i].SelectedIndex = 0;
                                        _CheckBox[i].Checked = true;
                                    }
                                }
                            }
                            else
                            {
                                if (j == 0)
                                {
                                    _GroupBoxs[i].Enabled = false;
                                    _CheckBox[i].Enabled = false;
                                }
                            }
                        }
                    }
                }

                for (i = 0; i < 9; i++)
                {
                    _RadioButtons[i * 2].CheckedChanged += radioButton_CheckedChanged;
                    _RadioButtons[i * 2 + 1].CheckedChanged += radioButton_CheckedChanged;
                    _ComboBox[i].SelectedIndexChanged += comboBox_SelectedIndexChanged;
                    _CheckBox[i].CheckedChanged += checkBox_CheckedChanged;
                }
            }
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            if (!bNuvotonIO)
            {
                Application.Exit();
            }

            bUnderPolling = false;
            timer1.Enabled = true;
        }

        private void comboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            int i, j;
            byte bMode, bData;
            ComboBox cb = (ComboBox)sender;

            for (i = 0; i < 9; i++)
            {
                if (_ComboBox[i] == cb)
                {
                    j = _ComboBox[i].SelectedIndex;

                    if ((GPIOEn[i] & (byte)(1 << j)) == 0)
                    {
                        _CheckBox[i].Enabled = false;
                        _GroupBoxs[i].Enabled = false;
                    }
                    else
                    {
                        _CheckBox[i].Enabled = true;

                        bMode = NuvHwAccCtrl._GetGpioMode(i, j);
                        if (bMode == 0x00)
                        {
                            _CheckBox[i].Checked = true;
                            _GroupBoxs[i].Enabled = true;
                        }
                        else
                        {
                            _CheckBox[i].Checked = false;
                            _GroupBoxs[i].Enabled = false;
                        }

                        NuvHwAccCtrl.LogDebug(String.Format("COMBOBOX_CHANGE"));
                        bData = NuvHwAccCtrl._GetGpioData(i, j);
                        if (bData == 0x00)
                        {
                            _Labels[i].Text = "0";
                            _RadioButtons[i * 2].Checked = true;
                        }
                        else
                        {
                            _Labels[i].Text = "1";
                            _RadioButtons[i * 2 + 1].Checked = true;
                        }
                    }
                }
            }
        }

        private void checkBox_CheckedChanged(object sender, EventArgs e)
        {
            int i, j;
            CheckBox cb = (CheckBox)sender;

            for (i = 0; i < 9; i++)
            {
                if (_CheckBox[i] == cb)
                {
                    j = _ComboBox[i].SelectedIndex;

                    if (_CheckBox[i].Checked)
                    {
                        NuvHwAccCtrl._SetGpioMode(i, j, 0);
                        _GroupBoxs[i].Enabled = true;
                    }
                    else
                    {
                        NuvHwAccCtrl._SetGpioMode(i, j, 1);
                        _GroupBoxs[i].Enabled = false;

                        NuvHwAccCtrl.LogDebug(String.Format("CHECKBOX_CHANGE"));
                        if (NuvHwAccCtrl._GetGpioData(i, j) == (byte)0x00)
                        {
                            _Labels[i].Text = "0";
                            _RadioButtons[i * 2].Checked = true;
                        }
                        else
                        {
                            _Labels[i].Text = "1";
                            _RadioButtons[i * 2 + 1].Checked = true;
                        }
                    }
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int i, j;

            bUnderPolling = true;

            for (i = 0; i < 9; i++)
            {
                if (_CheckBox[i].Checked == false)
                {
                    j = _ComboBox[i].SelectedIndex;

                    if (NuvHwAccCtrl._GetGpioData(i, j) == (byte)0x00)
                    {
                        _Labels[i].Text = "0";
                        _RadioButtons[i * 2].Checked = true;
                    }
                    else
                    {
                        _Labels[i].Text = "1";
                        _RadioButtons[i * 2 + 1].Checked = true;
                    }
                }
            }

            bUnderPolling = false;
        }

        private void radioButton_CheckedChanged(object sender, EventArgs e)
        {

            int i, j, k;

            if (((RadioButton)sender).Checked)
            {
                RadioButton rb = (RadioButton)sender;

                for (i = 0; i < 18; i++)
                {
                    if (_RadioButtons[i] == rb)
                    {
                        j = i / 2;
                        k = _ComboBox[j].SelectedIndex;
                        NuvHwAccCtrl._SetGpioData(j, k, (byte)(i % 2));
                    }
                }
            }

        }
    }
}
