﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using NNuvHwAccCtrl;
using System.IO;

namespace WDTSet
{
    public partial class Form1 : Form
    {
        static bool bLoad;
        static bool bNuvotonIO;
        int i, j;

        public Form1()
        {
            InitializeComponent();
            string logFilePath = Path.Combine(Application.StartupPath, "log4net.config");
            FileInfo finfo = new FileInfo(logFilePath);
            log4net.Config.XmlConfigurator.ConfigureAndWatch(finfo);

            bLoad = NuvHwAccCtrl.NuvHwCtrl_Load();
            if (bLoad == false)
            {
                this.Text = "Load Driver Fail";
            }

            bNuvotonIO = NuvHwAccCtrl.CheckSIO();
            if (!bNuvotonIO)
            {
                MessageBox.Show("NCT6116 can't be found", "Important Note", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                return;
            }
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            if (!bNuvotonIO)
            {
                Application.Exit();
            }

            comboBox1.SelectedIndex = 30;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Validate input data
            int iTimeout = comboBox1.SelectedIndex;

            // Enable pin 77, WDTO
            if (radioButton1.Checked == true)
                NuvHwAccCtrl._EnableWDTO(iTimeout, 0);
            else
                NuvHwAccCtrl._EnableWDTO(iTimeout, 1);
        }
    }
}
